#include "terrain.h"
class StarSystem;
const int numcontterr=4;
class ContinuousTerrain {
  Vector Scales;
  float sizeX;
  float sizeZ;
  int width;
  int numcontterr;
  Terrain **data;
  Matrix transformation;
  Vector *location;
  bool *dirty;
  bool checkInvScale(float &pos, float campos, float size);
 public:
  ContinuousTerrain (const char* filenameUL, const Vector & Scales=Vector (0,0,0), const float mass=0);
  void SetTransformation (Matrix transformation);
  /**
   *  Centers terrain around camera
   */
  void AdjustTerrain(StarSystem *);
  ~ContinuousTerrain();
  void DisableDraw();
  void EnableDraw();
  void DisableUpdate();
  void EnableUpdate();
  void Draw();
  Vector GetGroundPosIdentTrans (Vector ShipPos, Vector &norm);
  Vector GetGroundPos(Vector ShipPos, Vector & norm);
  Vector GetUpVector (const Vector & pos);
  void Collide (Unit * un, Matrix trans);
  void Collide (Unit * un);
  void Collide ();
  void GetTotalSize (float &X, float &Z) {X = sizeX;Z = sizeZ;}
};
